#include "iom16.h"
#define a 1
#define b 4
#define c 16
#define d 64  //   
#define e 128
#define f 2
#define g 8
#define DP 32

unsigned char      Dig[10];
//     ,   
char               Disp5, Disp6, Disp7;

//       Number
void Display (unsigned char Number)
{
  unsigned char Num1, Num2, Num3;
  Num1=Num2=0;
  while (Number >= 100)  
  {
    Number -= 100;  
    Num1++;  
  }
  while (Number >= 10) 
  {
    Number -= 10;  
    Num2++; 
  }
  Num3 = Number;
  Disp5 = Dig[Num1];
  Disp6 = Dig[Num2];
  Disp7 = Dig[Num3];
}

void USART_init()
{
  UCSRA = (1 << 1); //   
  UCSRB |= (1 << 7) | (1 << 4) | (1 << 3); //    ,    
  UCSRC |= (1 << 7); //   UCSRC
  UCSRC |= (1 << 1) | (1 << 2); //    8 
  UCSRC -= 128; //   UBRRH
  UBRRH = 0;
  UBRRL = 11; //   115200   
}

void Dig_init()
{
  Dig[0] = (a+b+c+d+e+f);
  Dig[1] = (b+c);
  Dig[2] = (a+b+g+e+d);
  Dig[3] = (a+b+g+c+d);
  Dig[4] = (f+g+b+c);
  Dig[5] = (a+f+g+c+d);
  Dig[6] = (a+f+g+c+d+e);
  Dig[7] = (a+b+c);
  Dig[8] = (a+b+c+d+e+f+g);
  Dig[9] = (a+b+c+d+f+g);
}

void io_init() //   /
{
  DDRA = 0xFF;
  PORTA = 0;
  DDRC |= (1 << PINC5) | (1 << PINC6) |(1 << PINC7);
  PORTC = 0;
  DDRB = 1;
}

void main()
{
  unsigned char j, k = 0;
  USART_init();
  Dig_init();
  Display(0);
  SREG |= (1 << 7);
  io_init();
  while(1) //   
  {
    for (j = 0; j <= 50; j++){} //    
    (k == 3) ? k = 0 : k++;
    PORTC &= 31;  // PC7, PC6, PC5
    for (j = 0; j<=30; j++){} //    
    switch (k)
    {
      case 0: PORTC |= (1 << PINC7); // 
              PORTA = Disp7;
        break;
      case 1: PORTC |= (1 << PINC6); // 
              PORTA = Disp6;
        break;
      case 2: PORTC |= (1 << PINC5); // 
              PORTA = Disp5;
    }  
  }
}

#pragma vector = USART_RXC_vect
__interrupt void Recieve()
{
  unsigned char temp = 0;
  unsigned char* str = " Hello! My name is AtMega16! "; //  
  char t,l;
  temp = UDR; //   
  Display (temp); //    
  PORTB = 1 - PORTB;
  if (temp == 5) //  ,     5
  {
    for (t=0; t < 28; t++)
    {
      UDR = str[t]; //  
      for (l=0; l < 200; l++) //  (   )
      { }
    }
  }
  else
  UDR = temp; //    
}
